# Generated by Django 3.2 on 2021-04-18 13:49

from django.db import migrations, models


def delete_all_positions(apps, schema_editor):
    Position = apps.get_model("seawatch_registration", "Position")
    # This will remove the positions from the applications, which isn't great, but given
    # that we don't have production data yet it's fine.
    Position.objects.all().delete()


def create_new_positions(apps, schema_editor):
    Position = apps.get_model("seawatch_registration", "Position")
    positions = [
        Position(
            key="master", name="Master", name_en_us="Master", name_de="Kapitän*in"
        ),
        Position(
            key="1st-officer",
            name="1st Officer",
            name_en_us="1st Officer",
            name_de="Erste*r Offizier*in",
        ),
        Position(
            key="2nd-officer",
            name="2nd Officer",
            name_en_us="2nd Officer",
            name_de="Zweite*r Offizier*in",
        ),
        Position(
            key="chief-eng",
            name="Chief Engineer",
            name_en_us="Chief Engineer",
            name_de="Leitende*r Ingenieur*in",
        ),
        Position(
            key="2nd-3rd-eng",
            name="2nd/3rd Engineer",
            name_en_us="2nd/3rd Engineer",
            name_de="Zweite*r / Dritte*r Ingenieur*in",
        ),
        Position(
            key="ship-elec-it",
            name="Ship’s Electrician/IT",
            name_en_us="Ship’s Electrician/IT",
            name_de="Schiffselektriker*in / ITler*in",
        ),
        Position(key="bosun", name="Bosun", name_en_us="Bosun", name_de="Bosun"),
        Position(
            key="ab-seaman",
            name="Deck rating",
            name_en_us="Deck rating",
            name_de="Matros*in",
        ),
        Position(
            key="guest-coord",
            name="Guest Coordinator",
            name_en_us="Guest Coordinator",
            name_de="Gastkoordinator*in",
        ),
        Position(key="cook", name="Cook", name_en_us="Cook", name_de="Köch*in"),
        Position(
            key="rib-driver",
            name="RIB Driver",
            name_en_us="RIB Driver",
            name_de="RIB-Fahrer*in",
        ),
        Position(
            key="medic", name="Medic", name_en_us="Medic", name_de="Mediziner*innen"
        ),
        Position(
            key="cult-coord",
            name="Cultural Mediator",
            name_en_us="Cultural Mediator",
            name_de="Interkulturelle Mediator*in",
        ),
        Position(
            key="media-coord",
            name="Media Coordinator",
            name_en_us="Media Coordinator",
            name_de="Medienkoordinator*in",
        ),
        Position(
            key="hom",
            name="Head of Mission",
            name_en_us="Head of Mission",
            name_de="Einsatzleiter*in",
        ),
    ]
    for position in positions:
        position.save()


class Migration(migrations.Migration):
    # By default, the whole migration runs in a transaction. This means that the old
    # positions aren't actually deleted right away and adding the field fails with an
    # error about pending trigger events.
    atomic = False

    dependencies = [
        ("seawatch_registration", "0026_auto_20200127_1741"),
    ]

    operations = [
        migrations.RunPython(delete_all_positions),
        migrations.AddField(
            model_name="position",
            name="key",
            field=models.CharField(default="", max_length=100, unique=True),
            preserve_default=False,
        ),
        migrations.RunPython(create_new_positions),
    ]
